Overview
Top Next

Bulk Rename Utility is a simple utility which allows you to rename multiple files and folders, based upon flexible criteria. For example, you can add a prefix or suffix to a file, or you can change three letters with four other letters in a filename. There are lots of ways to manipulate file and folder names.

Quick-Start Tips
· Only SELECTED filenames will be processed
· A full explanation of the various screen fields can be found here.
· Only when you make at least one file/directory selection will the RENAME button be enabled.

The application supports flexible renaming criteria, including:

· Select files and/or folders
· Files and/or Folders
· Full support for Perl-5 Regular Expressions
· Change the file name, or use a fixed filename
· Convert the extension to lower case, upper case, title case - or replace it - or add a secondary extension - or remove it - or leave it alone!
· Replace text with other text
· Add a fixed prefix
· Add a fixed suffix
· Add text to the middle of a name
· Remove the first n characters
· Remove the last n characters
· Remove from the nth character to the nth character
· Remove a list of characters
· Remove all digits, characters or symbols
· Change to lower case
· Change to title case
· Auto-number files, with a prefix or suffix, and with a predefined minimum-length if required.
· Prefix or suffix the filename with various dates (date-modified, accessed, created, or today's date), in many different formats with variable separators
· Append the folder name to the file
· Full support for Regular Expressions
· Store your frequently-used criteria as Favourites
· Copy the renamed files to a new location

All of these changes automatically ignore the filename extension, as it's usually dangerous to change the extension for a file. However, you can change the extension case to a fixed extension, and you can also remove an extension. You can choose to ignore extensions within folder names (but not filenames)

The application supports Favourites, which allows quick access to frequently-used rename configurations.

Directory recursion is also fully supported, allowing you to process directories and sub-directories.

This application is continually being enhanced. If you like the application, but have some suggestions for enhancements or improvements, then please get in touch. If you don't like the application then please tell me what you don't like! I would add some more functionality (e.g. allow conversion of double-spaces to single-spaces, allow removal of leading spaces) etc., but I'm struggling to find the room on the screen! If anyone has any bright ideas......

This help file is accurate as of version 2.1.0.12 (or later) of the Utility.


About Bulk Rename Utility
Previous Top Next

The Bulk Rename Utility was written by Jim Willsher using Visual C++ with the Microsoft Foundation Classes (MFC) architecture. It is a true 32-bit application, designed and built for 32-bit platforms.

Previous versions of this application were written in Visual Basic, but I wanted to teach myself MFC-development so this seemed an ideal opportunity.

Very special thanks go to Paolo Messina. Paolo provided the source code which makes it easy to create "resizeable" dialogues in MFC, and he also provided the functionality for the "tree" navigator on the left hand side of the utility. But over and above that, Paolo made enhancements to my code and fixed the bugs that I couldn't find. If it wasn't for Paolo then this utility might still be a Visual Basic application!

Thanks also go to Jeff, Nigel, Bill Pratt, David A., Frans, Chris and many others for their excellent suggestions, and testing of new functionality, in the Visual Basic and C++ versions. An application is nothing without input from its users.

Much of the help-file content was provided by Dave Williams. Dave is a user of the utility, so recognises what a user likes to see in a help file. I wrote the software so I know what every function does - but much of it might be completely alien to a new user, which is exactly why Dave's input was so useful!

The logic for the Tip Of The Day was based upon existing work by Robert Pittenger at www.codeproject.com.

The logic for the Splitter Window was based upon existing work by Maq at www.codeguru.com.

The Regular Expression logic uses the excellent PCRE Library available here.

The EXIF tag extractor is by Davide Pizzolato, based on jhead by Matthias Wandel.

The new icon was very kindly created and supplied by Christoph Mayar.

If you have any comments or suggestions about the application, or find any errors in the application, then please get in touch. The latest version of the application can always be downloaded from my website.

My email address is jim@jimwillsher.co.uk for support issues and suggestions.
The support website is www.bulkrenameutility.co.uk or www.jimwillsher.co.uk

Application updates are available from www.bulkrenameutility.co.uk. Alternatively, just click here to visit the application's homepage. You can also use the Check For Updates menu option on the Help menu - this requires an internet connection.

Copyright Jim Willsher 2000-2004.


Launching the application

When you run the application for the very first time you will be presented with the main window, located in the centre of the screen. This will only happen the first time - subsequent launches will position the window wherever you left it. This is true of all windows - the position of the window is retained between sessions.

In addition, whenever you re-launch the application most of the settings from your previous session will be retained, such as the directory and file-filter you were using. This is especially true if you are using Favourites.

Only one instance of the application may be launched. If you try to run the application, and there is already a version running, then the original instance will be displayed.

If you chose the Complete installation option then the easiest way to access the Bulk Rename Utility dialog is from Windows Explorer itself. Simply highlight the folder or folder containing files which you wish to rename, and then either right-click or press shift Function Key 10 and select "Bulk Rename" from the context menu. (NB This option doesn't apply to UNC drives, e.g. shares in Network Neighbourhood, unless you have a drive letter mapped to that share). Also, if you've previously saved a Favourite then you can double-click that favourite to launch the application.

For an overview of the main screen layout, click here.

The first time you launch the Utility you will see a Tip Of The Day screen. You can view the tips, and you can prevent them from showing again. To see Tips manually, just choose the menu option.


Renaming Files and Folders

It is really easy to rename files and folders. (For an overview of the main screen layout, and guidance on the various controls, click here.)

1. Select the folder which contains the objects you wish to rename. If required, you may also specify a file filter to restrict your list.
2. Enter the renaming criteria. The column beside the filename will show you what the new filename will become.
3. Select the files you wish to process (use CTRL or SHIFT to select multiple files).
4. Hit the Rename button. (This button is not enabled unless you have selected one or more files/folders to rename!)

Note that, to select a folder to process, you can either:
· Use the tree to navigate to the folder
· Right-click a folder in Windows Explorer and choose Bulk Rename
· Press Ctrl-J to jump to a folder

Hint: You can sort the file list using the column headers, as you would do in Explorer. The files will always be processed in the displayed sequence - useful when you're using the Numbering facility.

Please note that, if you rename a folder whilst using the recursive option, after the rename is complete the file list will be refreshed automatically. This is to prevent problems whereby the file-list becomes out of synchronisation with the files on your hard drive. If you don't rename a folder (just files), or if you rename anything whilst not using the recursive option, then no refresh is necessary.

mainscreen

The criteria are processed from left to right, according to the number listed against each section. So for example, a text replace will be performed before a change of case. The specific operations are as follows:

1) Apply any Regular Expression reformatting

then

2) Remove any file name, or use a fixed name,

then

3) Perform any text substitutions

then

4) Perform any changes of case

then

5) Remove n digits from the start, middle or end of the filename, and optionally remove certain characters, and/or all characters, and/or all digits and/or all symbols and/or all high-ascii characters.

then

6) Add any prefixes or suffixes, or apply text to the middle of the filename. Suffixes are added at the end of the filename, i.e. before any file extension

then

7) Apply any "auto-date" text as a prefix or suffix. "Sep" is the text to insert between the filename and the date; "Seg" is the separator between the day, month, year, hour, minute and second segments. Or you can use a custom format.

then

8) Add the containing folder name as a prefix or a suffix, with a user-defined separator

then

9) Perform any auto-numbering

then

10) Make any changes to the case of the file extension, or change the extension.

Full details about the various fields can be found here.

If you are not using the Regular Expression facility then both the Regular Expression Match and Replace fields must be left blank.

The selected files will be renamed according to your selection criteria. You can select multiple files by holding down the SHIFT or CTRL keys. If there are any problems with the rename operation then you will be given the option to roll back (undo) the operation.

Remember - you can always preview the new name in the column on the far right. This allows you to refine your criteria before actually renaming the files.

To preserve your renaming criteria for the next time you use the utility, look at the Favourites facility.

You can use the Reset button to reset all your renaming criteria back to the default values.

Remove Symbols

Note that the "Remove Symbols" option removes the following symbols (some of which are not valid in filenames anyway):

! £ $ % ^ & * ( ) - _ = + [ ] { } ; : ' @ # ~ , . < > / ? \ | ` ¬ ¦


The Main Screen

Once you launch the application the main screen is laid out in a similar way to Windows Explorer. Below the menu bar are two panes, the left of which is a tree view providing easy access to your system drives and folders. The right-hand pane is a list view of the files and folders contained within the currently selected branch of the tree shown over on the left.

Below the navigation panes are a series of controls. The controls are grouped together according to function - for example, all the facilities to remove text from a filename.

The rules used by the Bulk Rename Utility are processed in the order that the controls appear. i.e. from left to right. For example, you can't convert case before performing a replacement. However, it maybe possible to achieve the desired results by using the Bulk Rename Utility multiple times on the same folders and files using different rules. Names are not actually changed until the "Rename" button is clicked, but you can always see a preview of the proposed filename in the New Name column. Note that this column is only updated for the files which are selected.
`
If you have any of the criteria set in such a way that it will affect the filenames (i.e. it contributes to the new filename) then the title of that grouping will be shown with a yellow background (assuming you haven't disabled this option on the Options menu), as shown below:

The controls at the bottom of the screen can be explained as follows:

Expression

This allows you to enter a regular expression match and replace. Regular Expressions are a complex subject (a 400-page book exists on the subject) - more details can be found here. If you are not using Regular Expressions then both of these fields must be left blank. Do not confuse these fields with the Replacements fields found elsewhere on the screen.

Filename - this allows you to manage the actual raw filename

Filename drop-down - This control has three options: Keep, Remove and Fixed.
· Keep will ensure that the original filename is not changed (default).
· Remove will completely erase the filename from the selected items.
· Fixed allows a new filename to be specified for all selected items. Only really useful if you're also using the Numbering section.

Replacements - allow you to replace occurrences of one text string with another

This section consists of two controls. You must specify the text you wish to find, and the text you wish to replace it with. It is possible to find a text string and replace it with an empty string, or with a shorter string, or with a longer string. You may also specify whether or not you want the "find" processing to be case-sensitive. Note that the text is always replaced with the text you specify, including any specific text case.

Case - Allow the changing of case

Case drop-down - allows the capitalisation of file and/or folder names to be changed.
· Same - leaves the original capitalisation intact.
· Lower - converts all letters in the name(s) to lower-case.
· Upper - converts all letters in the name(s) into capitals.
· Title - converts all the words in the selected items to initial caps. A word is generally defined as a string of letters proceeded by a space or a bracket. So "joe public.txt" would become "Joe Public.txt" but "joe-public.txt" would become "Joe-public.txt".

Removals - Remove parts of a filename

This section consists of four separate facilities for removing parts of a filename. Note that these do not apply to the file extension, just the name.
· First n chars - Remove the first n characters from the name. E.g. removing the first 2 characters from "Joe Public.txt" will result in "e Public.txt"
· Last n chars - Remove the last n characters from the name. E.g. removing the last 2 characters from "Joe Public.txt" will result in "Joe Publ.txt"
· From n to n. This allows you to remove a string of text, e.g. from the 6th to the 9th characters.
· Chars - Remove occurrences of characters from the name. E.g. typing "QW:#" will result in all occurrences of Q, W, colon and hash being removed.
· Digits - Remove all occurrences of the digits 0-9 from the filename.
· High - Remove high-ASCII characters (chars from 128 to 255)

Additions - Add a fixed prefix or suffix to the filename

This allows you to add a fixed text string to the start of the filename, and also a fixed text string to the end of a filename. Useful for renaming MP3 files, where you can prefix all the filenames with the artist or album name. YOu can also insert a text string at any point in the filename.

Auto Date - Add various dates to the filename, in various formats

This allows you to prefix or suffix the filename with a variety of dates - the date that the file was created, modified, or accessed, and also with the current date. Useful for pictures! The date can be added in 9 different formats, some of which also include the modification time. You can also specify the characters you would like placed between the date/time and the existing filename (the Sep field) and the character to place between the different date/time segments (the Seg field). e.g. a format of DMY, with a Seg field of "-" would give a date of (for example) "25-01-03". The "Cent." flag is used to indicate whether or not you would the year to be represented with two digits or 4 digits.

You also have the option to specify your own custom date formats, and these are detailed here.

One of the dates you can use is "data taken". This is an EXIF flag which is often embedded in JPEG images which were created using a digital camera. The software will only get the flags from JPEG images (.JPG or .JPEG extension), not TIFFs. If no date is available then no date will be used. So for example, choosing to append the Date Taken for a .EXE file will simply append nothing.

Folder Name - Add the name of the containing folder

This option allows you to append (or prepend) the name of the containing folder to the filename. So for example, if you had a file called "Dancers.jpg" in a folder called "Highland Show August 2003" then you could automatically rename the file "Highland Show August 2003 - Dancers.jpg". Useful if you have lots of folders, each containing the same group of files, and you want to merge all the files into a single folder.

Numbering -

This allows you to sequentially number a group of files. Several criteria exist:
· Mode - specify whether you want the number to be appended to the start of the filename, or the end of the filename, or both.
· Start - Specify a starting number
· Increment - The number by which you want each filename number to be incremented
· Pad - The minimum number of digits occupied by the numeric element.
· Separator - A character or characters that you wish to be inserted between the filename and the number

A common scenario would be:
· Mode - Suffix
· Start - 1
· Increment - 1
· Pad - 4
· Separator - -

This would result in filenames with suffixes of -0001, -0002, -0003, -0004 etc.

You can choose to append the auto-number in any numeric base, from base 2 to base 36. e.g. a value of 26 in base 16 would be appended as 1A.

Extension - Allow the changing of case of the filename extension

Case drop-down - allows the capitalisation of file and/or folder names to be changed.
· Same - leaves the original capitalisation intact.
· Lower - converts all letters in the extension to lower-case.
· Upper - converts all letters in the extension into capitals.
· Title - converts all the words in the selected items to initial caps, e.g. Jpeg.
· Fixed - replace the extension with a fixed extension. For example, use this option to set all your files to ".doc" types.
· Extra - Add a secondary extension. For example, change my.holiday to my.holiday.gif
· Remove - Remove any file extension. e.g. My.Holiday becomes My

Selections - which files or folders you are working on. This is known as the file mask. By default this will be all the files and folders in the current folder. Note that this section is only used to govern which files/folders are displayed. You still need to select a file or folder in order to rename it.

· Filter - specify a file-mask to use. Normally this would be *.*, or *.mp3, or *.doc etc. Note that this section is only used to govern which files/folders are displayed. You still need to select a file or folder in order to rename it. So for example, entering a filter of "*.mp3" means that only your MP3 music files will be shown.
· Folders - include folders in the listing
· Files - include files in the listing.
· Recursive - if the Recursive checkbox is checked, Bulk Rename Utility will process the contents of all sub-folders in the selected branch of the file hierarchy. Care should be taken when using this feature as when instructed, the utility can potentially rename every file on the system. Please see the Terms and Conditions of use.
· Hidden - checking this box will mean that they will be processed. Important - you should be careful using this option as many Windows system files are hidden and renaming them could have a detrimental effect on the functionality of your system.
· Min. Len. - only files/folders whose names are greater than (or equal to) this length will be processed. Useful if you want to rename files greater than 64 characters for putting onto a CD, for example. NB This will exclude files and folders, if the file/folder name is shorter than the nominated length. However, in a recursive scan, sub-folders will still be scanned regardless of the length if the subfolder's name

New Location - This allows you to leave the original files intact, but create copies of the files (with new names, of course) in a separate folder. This option will honour the "Overwrite Target Files" menu option.

Command Buttons

· Reset - This restores all the renaming criteria to their default values. Once this button is pressed the default action will be to leave any filename unchanged.
· R - at the top of each group of controls there is a button entitled simply R. This will reset the criteria in that particular box.
· Rename - Actually perform the rename operation, using the criteria you have entered, on the files you have selected. You can always see the number of selected files in the utility's status bar. Note that this button is enabled once you have selected one or more files for renaming.


Actions Menu

The actions menu provides you with a variety of shortcuts to speed up common tasks, and these are described below.

actions

Select All
This will quickly select all the files and folders in the file-list window.

Deselect All
This will de-select all the files and folders in the file-list window.

Jump to Path
This option will display a pop-up window, allowing you to the type a full pathname to navigate to. The path must exist (it will be validated) and it must map to a drive letter - UNC paths are not supported.

Refresh Files
This will refresh the contents of the right-hand file-list window

Refresh Tree
This will refresh the contents of the left-hand tree window. Note that you can refresh the contents of the selected branch by collapsing and re-expanding the branch.

Zoom
This allows you to launch a new window to edit the current text field. Space on the screen is limited, and some fields are quite small, so this option allows you to enter long text with ease.

Random Sort
This allows you to sort the file-list in a random sequence. Useful if you want to create a slideshow in a random display-sequence. Once you've sorted in random order, apply a numeric auto-number prefix to keep the list in that order.


Options Menu

The options menu provides you with a variety of methods to customise the application. These are described below.

options

Always On Top
This will keep the Rename Utility window on top of all other windows.

Favourites > Save On Exit
This will save any changes to the current Favourite whenever you exit the application.

Favourites > Store Pathname
If you store the pathname with a Favourite, when you choose the Favourite the saved path is also selected. If you un-tick this option, selecting a new Favourite will leave you in the current folder.

Display > Gridlines
Some people like gridlines, others don't. You decide!

Display >Icons
Choosing to not display icons can sometimes speed up long file-listings

Display > Highlight Active Criteria
With this option ticked, whenever you make a change to one of the "criteria groupings" (e.g. Additions, Removals) that will have an effect on the filenames, the heading for that grouping will be highlighted. This allows you to quickly identify which of the groupings is having an effect on your filename. An example is shown below, where there is an active criteria in place - the heading is now yellow:

criteriahighlight

Of course, you can quickly press the "R" icon to reset the criteria for that grouping.

Display >Warning Message
This allows you to control whether or not you are warned prior to renaming files. Useful until you are confident with the software.

Display >Confirmation Message
Control whether or not you receive a confirmation message after the renaming is complete.

Colours > New Name OK...
This allows you to choose the colour used to display the new filename, if the new filename is acceptable to Windows. This means that it does not contain illegal characters.

Colours > New Name Invalid...
This allows you to choose the colour used to display the new filename, if the new filename is not acceptable to Windows. This means that it contains illegal characters such as \ or ?. The list of illegal characters is displayed if you attempt to rename the files.

Colours > Active Criteria...
This allows you to choose the colour used to highlight the active criteria. This is only applicable if you have opted to highlight active criteria on the Options > Display menu. Please note that any changes made to this option will not take effect until you restart the application.

Full Row Select
With this option ticked, when you select a file/folder the entire row will be highlighted. Without it ticked, only the first column will be highlighted. Note that files which will be renamed are highlighted in red text (right-hand column), but this is only possible when you don't select the Full Row Select option.

XP-Style Sorting
This option allows you to sort filenames according to the default XP sort-sequence. This allows files containing numbers to be sorted logically, e.g.1.txt, 2.txt, 10.txt, 11.txt, 21.txt. The default sort-sequence for all operating systems other than XP is to use absolute sorting, e.g. 1.txt, 10.txt, 11.txt, 2.txt, 21.txt. This option is only available for users of Windows XP - users of the non-XP version will not see this option.

Overwrite Target Files
With this option selected, if the destination filename for a rename operation already exists, that file will be overwritten. So for example, if you had files called a.txt, b.txt and c.txt, and your renaming-criteria caused file a.txt to become c.txt, file c.txt will be overwritten. As such, you need to use this option with extreme caution - if you enter incorrect renaming criteria then you could destroy valuable files very easily!

This option is honoured if you choose to copy files to a new location (box 12 on the screen).

Auto-Select Entries
With this option selected, when the list of files/folders is built, the files/folders will be selected automatically. This means you do not have to manually select entries in order to rename them.

Ignore Folder Extensions
With this option selected, any "extensions" within folder names will be ignored - this is because extensions have no real meaning, unlike filename extensions which identify the file type. So for example, if you have a folder called "Holidays.2004". and you choose to remove the last 2 characters, the resulting folder name will be "Holidays.20" or "Holida.2004", depending upon the status of this option.


Using Favourites

A Favourite is a collection of configuration values which can be used to provide quick access to commonly-used criteria. For example, if you frequently want to rename a bunch of pictures in one folder, and you frequently want to rename a bunch of sound files in another folder, then you could create two Favourite called Pictures and Sound Files. Each Favourite holds with it the selection criteria, rename criteria, and current folder.

When you launch the application for the first time you will not have any Favourites defined, but you can create favourites in the same was as you would create text files or pictures. Store them anywhere on your hard drive and use them as you wish.

Each individual Favourites file contains all the criteria you used to rename files. So for example, you could create a Favourite for renaming your pictures; a Favourite for stripping dodgy characters out of filenames etc. You can then recall these Favourites whenever you need them.

To use favourites, just use the Open and Save/Save As menu options in the same way as you would do in Word or Excel and other programs. When you choose to save a favourite, all the settings currently in place will be saved into that favourite. You can then recall these quickly, either from the Open command or by double-clicking a Favourite file in Windows Explorer. Favourites files have the file extension .bru


Regular Expressions

The applications support powerful Regular Expression processing. This allows you to enter a flexible Match expression, and a flexible Replacement expression, and the program will generate the appropriate name using these expressions. For example, you can use RegExp strings to swap two words in a filename, or remove numbers, or apply fixed formatting.

A full description of Regular Expressions is beyond the scope of this help file, but a wide range of resources is available on the internet (e.g. groups.google.com). However, the syntax supported by this program is the same as that offered by PERL 5. The precise implementation is via the PCRE Library, and (at the time of writing) full notes on the Perl Regular Expression syntax can be found here.

A summary of the syntax is:

Character | Usage
* | Matches the previous character zero or more times
+ | Matches the previous character one or more times
? | Matches the previous character zero or one times
. | Matches any single character except the newline
^ | Matches the start of the input
$ | Matches the end of the input
x|y | Matches either first or second character listed
(pattern) | Matches pattern
{number} | Matches exactly number times
{number,} | Matches number, or more, times (note comma)
{num1, num2} | Matches at least num1 and at most num2 times
[abc] | Matches any character listed between the [ ]
[^abc] | Matches all characters except those listed between the [ ]
[a-e] | Matches any characters in the specified range (a,b,c,d,e)
[^K-Q] | Matches all characters except in the specified range
\ | Signifies that the next character is special or a literal.
\b | Matches only on a word boundary
\B | Matches only inside a word
\f | Matches only on a form feed character
\n | Matches only on a new line
\r | Matches only on a carriage return
\s | Matches only on a blank space
\S | Matches only on nonblank spaces
\t | Matches only on a tab
\d | Matches any digit

Replacements are usually performed on the basis of "components, and these are defined using \ notation, e.g. \1 matches the first element, \2 matches the second

Example Regular Expression:

Match: (Louis Armstrong)(.\[0-9].)([A-Za-z ]*)
Replace: \1 \3

A more detailed working example can be found here.


Regular Expressions - A Working Example

Assume you have a file called Program Files, and you wish to swap the names around (e.g. Files Program). A Regular Expression which performs this task is :

^([A-Z][a-z]*) ([A-Z][a-z]*)

Let us break this down into components:

^ This means start at the beginning of the string
([A-Z][a-z]*) This is a single "group", which we will use later. What this says is that we want any capital letter, followed by any number of lower-case letters. The single capital letter is denoted by the [A-Z], i.e. allow a letter in the range A to Z. The lower-case letters are denoted by [a-z] in the same way, followed by an asterisk. This means we can allow any number of letters.

We then allow a single space. If I had wanted multiple spaces I would probably have typed "space asterisk", or possible ( *) to group.

We then have exactly the same again, i.e. we are denoting two words.

Notice we had two sets of brackets. Everything within each set of brackets is treated as a "grouping", and we refer to these groupings as \1, \2, \3 etc.

So, lets say we wanted to swap around the two words in the filename. We would put:

^([A-Z][a-z]*) ([A-Z][a-z]*)

For the match string, and

\2 \1

As the replacement string. Of course, we're free to manipulate the replacements string as we like. For example, it would be quite valid to have:

The \2 which are used to run the \1

For the replacement string.

The above example is very precise. If we wanted to swap the first two words of a name, but keep the remaining text the same, we could put

^([A-Z][a-z]*) ([A-Z][a-z]*)(.*)
\2\1\3

This says to create three groups: the first group is the first word, the second group is the second word, and the third group is everything that's left.

We could of case relax the restrictions on case-sensitivity too.


Bulk Rename From Here

During installation you are able to choose to install a Bulk Rename From Here facility. This is installed by default during a Complete install. This function adds a new menu option to the Windows Explorer context menu, which is accessed via the right mouse button.

If you right-click a folder within Windows Explorer you will see a facility entitled Bulk Rename From Here. Selecting this option will launch the Bulk Rename Utility, and will automatically select the folder you right-clicked within Explorer. This provides quick access to the utility.

If you are using the Presets facility, and you have selected the option to automatically save presets upon exit, then please be aware that the folder name stored against the preset will become the new folder.

For reasons of performance, if you use the Bulk Rename From Here function then the Recursive flag will be un-ticked, regardless of its stored setting. This is to prevent situations where you choose a high-level folder (e.g. C:\) without realising that a recursive directory search is about to be performed. The note regarding Favourites above also applies here.


Custom Date Formats

You can append a variety of dates to the filenames, either at the beginning or the end. For example, you could prefix the filenames with their Modified date, or you could suffix them with the Creation date.

A new feature, introduced in version 2.0.4.8, is the ability to add date and time information in a very flexible manner, using standard formatting codes. The full list of codes is defined below. So for example, if you wanted to suffix the filename with the day name and the month you could enter a custom code of "%a%M".

The full list of codes is:

Code | Meaning
%a | Abbreviated weekday name
%A | Full Weekday name
%b | Abbreviated month name
%B | Full month name
%d | Day of Month (01-31)
%H | Hour in 24-hour format (00-23)
%I | Hour in 12-hour format (01-12)
%j | Day of Year (01-366)
%m | Month number (01-12)
%M | Minute (00-59)
%p | AM/PM Indicator
%S | Seconds (00-59)
%U | Week number of year (00-53), with Sunday as the first day of the week.
%w | Weekday (0-6), with Sunday=0.
%W | Week number of year (00-53), with Monday as the first day of the week.
%y | Year, with no century indicator (00-99)
%Y | Year, with century indicator (e.g. 2004)
%z | Time zone name
%% | Percentage sign

You can enter other text in the filename, and the symbols above will be substituted with the values. So, you could enter a custom value of "Created on %a, %d %B, %Y" to get "Created on Tuesday, 25th March, 2004"


Recursive Scans

It is possible to perform a recursive scan and rename from the current folder. This allows you to rename folders and files contained within any subdirectories from the current folder. Subdirectories of subdirectories are also scanned, right down to the lowest level.

This option needs to be treated with great care - if you scan a high-level folder such as C:\ or C:\Program Files then the program could have tens of thousands of files to scan. Whilst the system should cope with in excess of 100,000 files, you will go mad waiting for the screen to be displayed!

As such, it is recommended that you only use the Recursive flag if you really need it.

Please note that, if you rename a folder whilst using the recursive option, after the rename is complete the file list will be refreshed automatically. This is to prevent problems whereby the file-list becomes out of synchronisation with the files on your hard drive. If you don't rename a folder (just files), or if you rename anything whilst not using the recursive option, then no refresh is necessary.


Quick Rename

Quick Rename via F2

If you want to quickly rename a file/folder manually, without applying any criteria, then you can press F2 on the filename and edit it manually. Simply press the enter key without making any changes to cancel the operation.

If you rename a folder, and you are in recursive mode, then the file list will be rebuilt.


Support
Previous Top

If you have any comments or suggestions about the application, or find any errors in the application, then please get in touch. The latest version of the application can always be downloaded from my website.

Remember, the easiest way to find your way around the application is to experiment. You won't do any harm unless you hit the Rename button, so you can play around with as many settings as you like!

My email address is jim@jimwillsher.co.uk for support issues and suggestions.

The application's homepage is at www.bulkrenameutility.co.uk.

If you get in touch with a problem then please email the following details:
· Your version of Windows (e.g. 98, 98SE, XP Home etc.)
· The version of the utility (found at Help, About)
· How to recreate the problem. The more details you can include, the better chance I have of finding the problem.

Please don't send large screen prints unless I request them - though small screen prints are fine. Please also note that my firewall automatically deletes emails with .ZIP attachments (I'm fed up getting bombarded with viruses!)

I will normally respond to emails the same day, subject to holidays etc.

With persistent problems I might ask you to install a special "debug enabled" version of the program. This will generate a trace file which I can use to analyse the problem.


.topic 10
Bulk Rename Utility is a simple utility which allows you to rename multiple files and folders, based upon flexible criteria. For example, you can add a prefix or suffix to a file, or you can change three letters with four other letters in a filename. There are lots of ways to manipulate file and folder names.

The application supports flexible renaming criteria, including:

Select files and/or folders
Files and/or Folders
Full support for Perl-5 Regular Expressions
Change the file name, or use a fixed filename
Convert the extension to lower case, upper case, title case - or replace it - or add a secondary extension - or remove it - or leave it alone!
Replace text with other text
Add a fixed prefix
Add a fixed suffix
Add text to the middle of a name
Remove the first n characters
Remove the last n characters
Remove from the nth character to the nth character
Remove a list of characters
Remove all digits, characters or symbols
Change to lower case
Change to title case
Auto-number files, with a prefix or suffix, and with a predefined minimum-length if required.
Prefix or suffix the filename with various dates (date-modified, accessed, created, or today's date), in many different formats with variable separators
Append the folder name to the file
Full support for Regular Expressions
Store your frequently-used criteria as Favourites
Copy the renamed files to a new location

All of these changes automatically ignore the filename extension, as it's usually dangerous to change the extension for a file. However, you can change the extension case to a fixed extension, and you can also remove an extension. You can choose to ignore extensions within folder names (but not filenames)

The application supports Favourites, which allows quick access to frequently-used rename configurations.

Directory recursion is also fully supported, allowing you to process directories and sub-directories.

This application is continually being enhanced. If you like the application, but have some suggestions for enhancements or improvements, then please get in touch. If you don't like the application then please tell me what you don't like! I would add some more functionality (e.g. allow conversion of double-spaces to single-spaces, allow removal of leading spaces) etc., but I'm struggling to find the room on the screen! If anyone has any bright ideas......

This help file is accurate as of version 2.1.0.12 (or later) of the Utility.

.topic 20
The Bulk Rename Utility was written by Jim Willsher using Visual C++ with the Microsoft Foundation Classes (MFC) architecture. It is a true 32-bit application, designed and built for 32-bit platforms.

Previous versions of this application were written in Visual Basic, but I wanted to teach myself MFC-development so this seemed an ideal opportunity.

Very special thanks go to Paolo Messina. Paolo provided the source code which makes it easy to create "resizeable" dialogues in MFC, and he also provided the functionality for the "tree" navigator on the left hand side of the utility. But over and above that, Paolo made enhancements to my code and fixed the bugs that I couldn't find. If it wasn't for Paolo then this utility might still be a Visual Basic application!

Thanks also go to Jeff, Nigel, Bill Pratt, David A., Frans, Chris and many others for their excellent suggestions, and testing of new functionality, in the Visual Basic and C++ versions. An application is nothing without input from its users.

Much of the help-file content was provided by Dave Williams. Dave is a user of the utility, so recognises what a user likes to see in a help file. I wrote the software so I know what every function does - but much of it might be completely alien to a new user, which is exactly why Dave's input was so useful!

The logic for the Tip Of The Day was based upon existing work by Robert Pittenger at www.codeproject.com.

The logic for the Splitter Window was based upon existing work by Maq at www.codeguru.com.

The Regular Expression logic uses the excellent PCRE Library available here.

The EXIF tag extractor is by Davide Pizzolato, based on jhead by Matthias Wandel.

The new icon was very kindly created and supplied by Christoph Mayar.

If you have any comments or suggestions about the application, or find any errors in the application, then please get in touch. The latest version of the application can always be downloaded from my website.

My email address is jim@jimwillsher.co.uk for support issues and suggestions.
The support website is www.bulkrenameutility.co.uk or www.jimwillsher.co.uk

Application updates are available from www.bulkrenameutility.co.uk. Alternatively, just click here to visit the application's homepage. You can also use the Check For Updates menu option on the Help menu - this requires an internet connection.

Copyright Jim Willsher 2000-2004.

.topic 30
When you run the application for the very first time you will be presented with the main window, located in the centre of the screen. This will only happen the first time – subsequent launches will position the window wherever you left it. This is true of all windows – the position of the window is retained between sessions.

In addition, whenever you re-launch the application most of the settings from your previous session will be retained, such as the directory and file-filter you were using. This is especially true if you are using Favourites.

Only one instance of the application may be launched. If you try to run the application, and there is already a version running, then the original instance will be displayed.

If you chose the Complete installation option then the easiest way to access the Bulk Rename Utility dialog is from Windows Explorer itself. Simply highlight the folder or folder containing files which you wish to rename, and then either right-click or press shift Function Key 10 and select "Bulk Rename" from the context menu. (NB This option doesn't apply to UNC drives, e.g. shares in Network Neighbourhood, unless you have a drive letter mapped to that share). Also, if you've previously saved a Favourite then you can double-click that favourite to launch the application.

For an overview of the main screen layout, click here.

The first time you launch the Utility you will see a Tip Of The Day screen. You can view the tips, and you can prevent them from showing again. To see Tips manually, just choose the menu option.

.topic 40
It is really easy to rename files and folders. (For an overview of the main screen layout, and guidance on the various controls, click here.)

1.	Select the folder which contains the objects you wish to rename. If required, you may also specify a file filter to restrict your list.
2.	Enter the renaming criteria. The column beside the filename will show you what the new filename will become.
3.	Select the files you wish to process (use CTRL or SHIFT to select multiple files).
4.	Hit the Rename button. (This button is not enabled unless you have selected one or more files/folders to rename!)

Note that, to select a folder to process, you can either:
Use the tree to navigate to the folder
Right-click a folder in Windows Explorer and choose Bulk Rename
Press Ctrl-J to jump to a folder

Hint: You can sort the file list using the column headers, as you would do in Explorer. The files will always be processed in the displayed sequence - useful when you're using the Numbering facility.

Please note that, if you rename a folder whilst using the recursive option, after the rename is complete the file list will be refreshed automatically. This is to prevent problems whereby the file-list becomes out of synchronisation with the files on your hard drive. If you don't rename a folder (just files), or if you rename anything whilst not using the recursive option, then no refresh is necessary.

The criteria are processed from left to right, according to the number listed against each section. So for example, a text replace will be performed before a change of case. The specific operations are as follows:

1) Apply any Regular Expression reformatting

then

2) Remove any file name, or use a fixed name,

then

3) Perform any text substitutions

then

4) Perform any changes of case

then

5) Remove n digits from the start, middle or end of the filename, and optionally remove certain characters, and/or all characters, and/or all digits and/or all symbols and/or all high-ascii characters.

then

6) Add any prefixes or suffixes, or apply text to the middle of the filename. Suffixes are added at the end of the filename, i.e. before any file extension

then

7) Apply any "auto-date" text as a prefix or suffix. "Sep" is the text to insert between the filename and the date; "Seg" is the separator between the day, month, year, hour, minute and second segments. Or you can use a custom format.

then

8) Add the containing folder name as a prefix or a suffix, with a user-defined separator

then

9) Perform any auto-numbering

then

10) Make any changes to the case of the file extension, or change the extension.

Full details about the various fields can be found here.

If you are not using the Regular Expression facility then both the Regular Expression Match and Replace fields must be left blank.

The selected files will be renamed according to your selection criteria. You can select multiple files by holding down the SHIFT or CTRL keys. If there are any problems with the rename operation then you will be given the option to roll back (undo) the operation.

Remember - you can always preview the new name in the column on the far right. This allows you to refine your criteria before actually renaming the files.

To preserve your renaming criteria for the next time you use the utility, look at the Favourites facility.

You can use the Reset button to reset all your renaming criteria back to the default values.

Remove Symbols

Note that the "Remove Symbols" option removes the following symbols (some of which are not valid in filenames anyway):

    ! £ $ % ^ & * ( ) - _ = + [ ] { } ; : ' @ # ~ , . < > / ? \ | ` ¬ ¦

.topic 200
Once you launch the application the main screen is laid out in a similar way to Windows Explorer. Below the menu bar are two panes, the left of which is a tree view providing easy access to your system drives and folders. The right-hand pane is a list view of the files and folders contained within the currently selected branch of the tree shown over on the left.

Below the navigation panes are a series of controls. The controls are grouped together according to function - for example, all the facilities to remove text from a filename.

The rules used by the Bulk Rename Utility are processed in the order that the controls appear. i.e. from left to right.  For example, you can't convert case before performing a replacement. However, it maybe possible to achieve the desired results by using the Bulk Rename Utility multiple times on the same folders and files using different rules. Names are not actually changed until the "Rename" button is clicked, but you can always see a preview of the proposed filename in the New Name column. Note that this column is only updated for the files which are selected.
`
If you have any of the criteria set in such a way that it will affect the filenames (i.e. it contributes to the new filename) then the title of that grouping will be shown with a yellow background (assuming you haven't disabled this option on the Options menu), as shown below:

The controls at the bottom of the screen can be explained as follows:

Expression

This allows you to enter a regular expression match and replace. Regular Expressions are a complex subject (a 400-page book exists on the subject) - more details can be found here. If you are not using Regular Expressions then both of these fields must be left blank. Do not confuse these fields with the Replacements fields found elsewhere on the screen.

Filename - this allows you to manage the actual raw filename

Filename drop-down - This control has three options: Keep, Remove and Fixed.
Keep will ensure that the original filename is not changed (default).
Remove will completely erase the filename from the selected items.
Fixed allows a new filename to be specified for all selected items. Only really useful if you're also using the Numbering section.

Replacements - allow you to replace occurrences of one text string with another

This section consists of two controls. You must specify the text you wish to find, and the text you wish to replace it with. It is possible to find a text string and replace it with an empty string, or with a shorter string, or with a longer string. You may also specify whether or not you want the "find" processing to be case-sensitive. Note that the text is always replaced with the text you specify, including any specific text case.

Case - Allow the changing of case

Case drop-down - allows the capitalisation of file and/or folder names to be changed.
Same - leaves the original capitalisation intact.
Lower - converts all letters in the name(s) to lower-case.
Upper - converts all letters in the name(s) into capitals.
Title - converts all the words in the selected items to initial caps.  A word is generally defined as a string of letters proceeded by a space or a bracket. So "joe public.txt" would become "Joe Public.txt" but "joe-public.txt" would become "Joe-public.txt".

Removals - Remove parts of a filename

This section consists of four separate facilities for removing parts of a filename. Note that these do not apply to the file extension, just the name.
First n chars - Remove the first n characters from the name. E.g. removing the first 2 characters from "Joe Public.txt" will result in "e Public.txt"
Last n chars - Remove the last n characters from the name. E.g. removing the last 2 characters from "Joe Public.txt" will result in "Joe Publ.txt"
From n to n. This allows you to remove a string of text, e.g. from the 6th to the 9th characters.
Chars - Remove occurrences of characters from the name. E.g. typing "QW:#" will result in all occurrences of Q, W, colon and hash being removed.
Digits - Remove all occurrences of the digits 0-9 from the filename.
High - Remove high-ASCII characters (chars from 128 to 255)

Additions - Add a fixed prefix or suffix to the filename

This allows you to add a fixed text string to the start of the filename, and also a fixed text string to the end of a filename. Useful for renaming MP3 files, where you can prefix all the filenames with the artist or album name. YOu can also insert a text string at any point in the filename.

Auto Date - Add various dates to the filename, in various formats

This allows you to prefix or suffix the filename with a variety of dates - the date that the file was created, modified, or accessed, and also with the current date. Useful for pictures! The date can be added in 9 different formats, some of which also include the modification time. You can also specify the characters you would like placed between the date/time and the existing filename (the Sep field) and the character to place between the different date/time segments (the Seg field). e.g. a format of DMY, with a Seg field of "-" would give a date of (for example) "25-01-03". The "Cent." flag is used to indicate whether or not you would the year to be represented with two digits or 4 digits.

You also have the option to specify your own custom date formats, and these are detailed here.

One of the dates you can use is "data taken". This is an EXIF flag which is often embedded in JPEG images which were created using a digital camera. The software will only get the flags from JPEG images (.JPG or .JPEG extension), not TIFFs. If no date is available then no date will be used. So for example, choosing to append the Date Taken for a .EXE file will simply append nothing.

Folder Name - Add the name of the containing folder

This option allows you to append (or prepend) the name of the containing folder to the filename. So for example, if you had a file called "Dancers.jpg" in a folder called "Highland Show August 2003" then you could automatically rename the file "Highland Show August 2003 - Dancers.jpg". Useful if you have lots of folders, each containing the same group of files, and you want to merge all the files into a single folder.

Numbering -

This allows you to sequentially number a group of files. Several criteria exist:
Mode - specify whether you want the number to be appended to the start of the filename, or the end of the filename, or both.
Start - Specify a starting number
Increment - The number by which you want each filename number to be incremented
Pad - The minimum number of digits occupied by the numeric element.
Separator - A character or characters that you wish to be inserted between the filename and the number

A common scenario would be:
Mode - Suffix
Start - 1
Increment - 1
Pad - 4
Separator - -

This would result in filenames with suffixes of -0001, -0002, -0003, -0004 etc.

You can choose to append the auto-number in any numeric base, from base 2 to base 36. e.g. a value of 26 in base 16 would be appended as 1A.

Extension - Allow the changing of case of the filename extension

Case drop-down - allows the capitalisation of file and/or folder names to be changed.
Same - leaves the original capitalisation intact.
Lower - converts all letters in the extension to lower-case.
Upper - converts all letters in the extension into capitals.
Title - converts all the words in the selected items to initial caps, e.g. Jpeg.
Fixed - replace the extension with a fixed extension. For example, use this option to set all your files to ".doc" types.
Extra - Add a secondary extension.  For example, change my.holiday to my.holiday.gif
Remove - Remove any file extension. e.g. My.Holiday becomes My

Selections - which files or folders you are working on. This is known as the file mask. By default this will be all the files and folders in the current folder. Note that this section is only used to govern which files/folders are displayed. You still need to select a file or folder in order to rename it.

Filter - specify a file-mask to use. Normally this would be *.*, or *.mp3, or *.doc etc. Note that this section is only used to govern which files/folders are displayed. You still need to select a file or folder in order to rename it. So for example, entering a filter of "*.mp3" means that only your MP3 music files will be shown.
Folders - include folders in the listing
Files - include files in the listing.
Recursive - if the Recursive checkbox is checked, Bulk Rename Utility will process the contents of all sub-folders in the selected branch of the file hierarchy.  Care should be taken when using this feature as when instructed, the utility can potentially rename every file on the system. Please see the Terms and Conditions of use.
Hidden - checking this box will mean that they will be processed. Important - you should be careful using this option as many Windows system files are hidden and renaming them could have a detrimental effect on the functionality of your system.
Min. Len. - only files/folders whose names are greater than (or equal to) this length will be processed. Useful if you want to rename files greater than 64 characters for putting onto a CD, for example. NB This will exclude files and folders, if the file/folder name is shorter than the nominated length. However, in a recursive scan, sub-folders will still be scanned regardless of the length if the subfolder's name

New Location - This allows you to leave the original files intact, but create copies of the files (with new names, of course) in a separate folder. This option will honour the "Overwrite Target Files" menu option.

Command Buttons

Reset - This restores all the renaming criteria to their default values. Once this button is pressed the default action will be to leave any filename unchanged.
R - at the top of each group of controls there is a button entitled simply R. This will reset the criteria in that particular box.
Rename - Actually perform the rename operation, using the criteria you have entered, on the files you have selected. You can always see the number of selected files in the utility's status bar. Note that this button is enabled once you have selected one or more files for renaming.

.topic 175
The actions menu provides you with a variety of shortcuts to speed up common tasks, and these are described below.

Select All
This will quickly select all the files and folders in the file-list window.

Deselect All
This will de-select all the files and folders in the file-list window.

Jump to Path
This option will display a pop-up window, allowing you to the type a full pathname to navigate to. The path must exist (it will be validated) and it must map to a drive letter - UNC paths are not supported.

Refresh Files
This will refresh the contents of the right-hand file-list window

Refresh Tree
This will refresh the contents of the left-hand tree window. Note that you can refresh the contents of the selected branch by collapsing and re-expanding the branch.

Zoom
This allows you to launch a new window to edit the current text field. Space on the screen is limited, and some fields are quite small, so this option allows you to enter long text with ease.

Random Sort
This allows you to sort the file-list in a random sequence. Useful if you want to create a slideshow in a random display-sequence. Once you've sorted in random order, apply a numeric auto-number prefix to keep the list in that order.

.topic 205
The options menu provides you with a variety of methods to customise the application. These are described below.

Always On Top
This will keep the Rename Utility window on top of all other windows.

Favourites > Save On Exit
This will save any changes to the current Favourite whenever you exit the application.

Favourites > Store Pathname
If you store the pathname with a Favourite, when you choose the Favourite the saved path is also selected. If you un-tick this option, selecting a new Favourite will leave you in the current folder.

Display > Gridlines
Some people like gridlines, others don't. You decide!

Display >Icons
Choosing to not display icons can sometimes speed up long file-listings

Display > Highlight Active Criteria
With this option ticked, whenever you make a change to one of the "criteria groupings" (e.g. Additions, Removals) that will have an effect on the filenames, the heading for that grouping will be highlighted. This allows you to quickly identify which of the groupings is having an effect on your filename. An example is shown below, where there is an active criteria in place - the heading is now yellow:

Of course, you can quickly press the "R" icon to reset the criteria for that grouping.

Display >Warning Message
This allows you to control whether or not you are warned prior to renaming files. Useful until you are confident with the software.

Display >Confirmation Message
Control whether or not you receive a confirmation message after the renaming is complete.

Colours > New Name OK...
This allows you to choose the colour used to display the new filename, if the new filename is acceptable to Windows. This means that it does not contain illegal characters.

Colours > New Name Invalid...
This allows you to choose the colour used to display the new filename, if the new filename is not acceptable to Windows. This means that it contains illegal characters such as \ or ?. The list of illegal characters is displayed if you attempt to rename the files.

Colours > Active Criteria...
This allows you to choose the colour used to highlight the active criteria. This is only applicable if you have opted to highlight active criteria on the Options >  Display menu. Please note that any changes made to this option will not take effect until you restart the application.

Full Row Select
With this option ticked, when you select a file/folder the entire row will be highlighted. Without it ticked, only the first column will be highlighted. Note that files which will be renamed are highlighted in red text (right-hand column), but this is only possible when you don't select the Full Row Select option.

XP-Style Sorting
This option allows you to sort filenames according to the default XP sort-sequence. This allows files containing numbers to be sorted logically, e.g.1.txt, 2.txt, 10.txt, 11.txt, 21.txt. The default sort-sequence for all operating systems other than XP is to use absolute sorting, e.g. 1.txt, 10.txt, 11.txt, 2.txt, 21.txt. This option is only available for users of Windows XP - users of the non-XP version will not see this option.

Overwrite Target Files
With this option selected, if the destination filename for a rename operation already exists, that file will be overwritten. So for example, if you had files called a.txt, b.txt and c.txt, and your renaming-criteria caused file a.txt to become c.txt, file c.txt will be overwritten. As such, you need to use this option with extreme caution - if you enter incorrect renaming criteria then you could destroy valuable files very easily!

This option is honoured if you choose to copy files to a new location (box 12 on the screen).

Auto-Select Entries
With this option selected, when the list of files/folders is built, the files/folders will be selected automatically. This means you do not have to manually select entries in order to rename them.

Ignore Folder Extensions
With this option selected, any "extensions" within folder names will be ignored - this is because extensions have no real meaning, unlike filename extensions which identify the file type. So for example, if you have a folder called "Holidays.2004". and you choose to remove the last 2 characters, the resulting folder name will be "Holidays.20" or "Holida.2004", depending upon the status of this option.

.topic 100
A Favourite is a collection of configuration values which can be used to provide quick access to commonly-used criteria. For example, if you frequently want to rename a bunch of pictures in one folder, and you frequently want to rename a bunch of sound files in another folder, then you could create two Favourite called Pictures and Sound Files. Each Favourite holds with it the selection criteria, rename criteria, and current folder.

When you launch the application for the first time you will not have any Favourites defined, but you can create favourites in the same was as you would create text files or pictures. Store them anywhere on your hard drive and use them as you wish.

Each individual Favourites file contains all the criteria you used to rename files. So for example, you could create a Favourite for renaming your pictures; a Favourite for stripping dodgy characters out of filenames etc. You can then recall these Favourites whenever you need them.

To use favourites, just use the Open and Save/Save As menu options in the same way as you would do in Word or Excel and other programs. When you choose to save a favourite, all the settings currently in place will be saved into that favourite. You can then recall these quickly, either from the Open command or by double-clicking a Favourite file in Windows Explorer. Favourites files have the file extension .bru

.topic 190
The applications support powerful Regular Expression processing. This allows you to enter a flexible Match expression, and a flexible Replacement expression, and the program will generate the appropriate name using these expressions. For example, you can use RegExp strings to swap two words in a filename, or remove numbers, or apply fixed formatting.

A full description of Regular Expressions is beyond the scope of this help file, but a wide range of resources is available on the internet (e.g. groups.google.com). However, the syntax supported by this program is the same as that offered by PERL 5. The precise implementation is via the PCRE Library, and (at the time of writing) full notes on the Perl Regular Expression syntax can be found here.

A summary of the syntax is:

Replacements are usually performed on the basis of "components, and these are defined using \ notation, e.g. \1 matches the first element, \2 matches the second

Example Regular Expression:

Match:		(Louis Armstrong)(.\[0-9].)([A-Za-z ]*)
Replace:	\1 \3

A more detailed working example can be found here.

.topic 210
Assume you have a file called Program Files, and you wish to swap the names around (e.g. Files Program). A Regular Expression which performs this task is :

    ^([A-Z][a-z]*) ([A-Z][a-z]*)

Let us break this down into components:

^ This means start at the beginning of the string
([A-Z][a-z]*) This is a single "group", which we will use later. What this says is that we want any capital letter, followed by any number of lower-case letters. The single capital letter is denoted by the [A-Z], i.e. allow a letter in the range A to Z. The lower-case letters are denoted by [a-z] in the same way, followed by an asterisk. This means we can allow any number of letters.

We then allow a single space. If I had wanted multiple spaces I would probably have typed "space asterisk", or possible ( *) to group.

We then have exactly the same again, i.e. we are denoting two words.

Notice we had two sets of brackets. Everything within each set of brackets is treated as a "grouping", and we refer to these groupings as \1, \2, \3 etc.

So, lets say we wanted to swap around the two words in the filename. We would put:

    ^([A-Z][a-z]*) ([A-Z][a-z]*)

For the match string, and

    \2 \1

As the replacement string. Of course, we're free to manipulate the replacements string as we like. For example, it would be quite valid to have:

The \2 which are used to run the \1

For the replacement string.

The above example is very precise. If we wanted to swap the first two words of a name, but keep the remaining text the same, we could put

    ^([A-Z][a-z]*) ([A-Z][a-z]*)(.*)
    \2\1\3

This says to create three groups: the first group is the first word, the second group is the second word, and the third group is everything that's left.

We could of case relax the restrictions on case-sensitivity too.

.topic 170
During installation you are able to choose to install a Bulk Rename From Here facility. This is installed by default during a Complete install. This function adds a new menu option to the Windows Explorer context menu, which is accessed via the right mouse button.

If you right-click a folder within Windows Explorer you will see a facility entitled Bulk Rename From Here. Selecting this option will launch the Bulk Rename Utility, and will automatically select the folder you right-clicked within Explorer. This provides quick access to the utility.

If you are using the Presets facility, and you have selected the option to automatically save presets upon exit, then please be aware that the folder name stored against the preset will become the new folder.

For reasons of performance, if you use the Bulk Rename From Here function then the Recursive flag will be un-ticked, regardless of its stored setting. This is to prevent situations where you choose a high-level folder (e.g. C:\) without realising that a recursive directory search is about to be performed. The note regarding Favourites above also applies here.

.topic 220
You can append a variety of dates to the filenames, either at the beginning or the end. For example, you could prefix the filenames with their Modified date, or you could suffix them with the Creation date.

A new feature, introduced in version 2.0.4.8, is the ability to add date and time information in a very flexible manner, using standard formatting codes. The full list of codes is defined below. So for example, if you wanted to suffix the filename with the day name and the month you could enter a custom code of "%a%M".

The full list of codes is:

You can enter other text in the filename, and the symbols above will be substituted with the values. So, you could enter a custom value of "Created on %a, %d %B, %Y" to get "Created on Tuesday, 25th March, 2004"

.topic 180
It is possible to perform a recursive scan and rename from the current folder. This allows you to rename folders and files contained within any subdirectories from the current folder. Subdirectories of subdirectories are also scanned, right down to the lowest level.

This option needs to be treated with great care - if you scan a high-level folder such as C:\ or C:\Program Files then the program could have tens of thousands of files to scan. Whilst the system should cope with in excess of 100,000 files, you will go mad waiting for the screen to be displayed!

As such, it is recommended that you only use the Recursive flag if you really need it.

Please note that, if you rename a folder whilst using the recursive option, after the rename is complete the file list will be refreshed automatically. This is to prevent problems whereby the file-list becomes out of synchronisation with the files on your hard drive. If you don't rename a folder (just files), or if you rename anything whilst not using the recursive option, then no refresh is necessary.

.topic 100
If you want to quickly rename a file/folder manually, without applying any criteria, then you can press F2 on the filename and edit it manually. Simply press the enter key without making any changes to cancel the operation.

If you rename a folder, and you are in recursive mode, then the file list will be rebuilt.

.topic 80
If you have any comments or suggestions about the application, or find any errors in the application, then please get in touch. The latest version of the application can always be downloaded from my website.

Remember, the easiest way to find your way around the application is to experiment. You won't do any harm unless you hit the Rename button, so you can play around with as many settings as you like!

My email address is jim@jimwillsher.co.uk for support issues and suggestions.

The application's homepage is at www.bulkrenameutility.co.uk.

If you get in touch with a problem then please email the following details:
Your version of Windows (e.g. 98, 98SE, XP Home etc.)
The version of the utility (found at Help, About)
How to recreate the problem. The more details you can include, the better chance I have of finding the problem.

Please don't send large screen prints unless I request them - though small screen prints are fine. Please also note that my firewall automatically deletes emails with .ZIP attachments (I'm fed up getting bombarded with viruses!)

I will normally respond to emails the same day, subject to holidays etc.

With persistent problems I might ask you to install a special "debug enabled" version of the program. This will generate a trace file which I can use to analyse the problem.